SystemOrganization addCategory: #'AL-Rendering'!

Object subclass: #ALBrush
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALBrush class methodsFor: 'as yet unclassified' stamp: 'cwp 3/14/2011 00:57'!
on: aCanvas
	^ self basicNew initializeWithCanvas: aCanvas! !

!ALBrush methodsFor: 'initialize-release' stamp: 'cwp 7/19/2011 19:34'!
initializeWithCanvas: aCanvas
	self initialize.
	canvas := aCanvas.
! !

!ALBrush methodsFor: 'rendering' stamp: 'cwp 3/14/2011 00:47'!
with: aBlock
	canvas push.
	aBlock ensure:
		[canvas close.
		canvas pop]! !

!ALBrush methodsFor: 'writing' stamp: 'cwp 3/14/2011 11:59'!
writeCloseInto: aWriteStream
	self subclassResponsibility ! !

!ALBrush methodsFor: 'writing' stamp: 'cwp 3/14/2011 11:59'!
writeEmptyInto: aWriteStream
	self writeOpenInto: aWriteStream.
	self writeCloseInto: aWriteStream.! !

!ALBrush methodsFor: 'writing' stamp: 'cwp 3/14/2011 11:59'!
writeOpenInto: aWriteStream
	self subclassResponsibility ! !

Object subclass: #ALCanvas
	instanceVariableNames: 'stream stack current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALCanvas class methodsFor: 'as yet unclassified' stamp: 'cwp 3/13/2011 08:36'!
on: aStream
	^ self basicNew initializeWithStream: aStream! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 3/14/2011 00:45'!
close
	current ifNotNil: 
		[current writeEmptyInto: stream. 
		current := nil]! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 3/14/2011 01:07'!
flush
	self close.
	[stack isEmpty] whileFalse: [self pop]! !

!ALCanvas methodsFor: 'initialize-release' stamp: 'cwp 3/14/2011 00:38'!
initializeWithStream: aStream
	stream := aStream.
	stack := OrderedCollection new.
	current := nil.! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 3/14/2011 00:40'!
open: aTag
	current ifNotNil: [current writeEmptyInto: stream].
	^ current := aTag
	! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 3/14/2011 00:45'!
pop
	stack removeLast writeCloseInto: stream! !

!ALCanvas methodsFor: 'stack' stamp: 'cwp 3/14/2011 00:52'!
push
	current writeOpenInto: stream.
	stack add: current.
	current := nil! !

Object subclass: #ALRenderingContext
	instanceVariableNames: 'locator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Rendering'!

!ALRenderingContext class methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2011 23:14'!
locator: aLocator
	^ self basicNew initializeWithLocator: aLocator  ! !

!ALRenderingContext methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2011 23:14'!
initializeWithLocator: aLocator
	self initialize.
	locator := aLocator! !

!ALRenderingContext methodsFor: 'registering' stamp: 'cwp 7/21/2011 10:33'!
registerFacet: aFacet
	| resource |
	resource := ALDataResource facet: aFacet.
	^ locator pathForResource: resource  ! !

!ALRenderingContext methodsFor: 'registering' stamp: 'cwp 7/21/2011 09:41'!
registerLink: aBlockClosure 
	^ 'xxx'! !
